#include "cbase.h"
#include "monstermaker.h"

#ifndef SP2_BUGPOI_H
#define SP2_BUGPOI_H

class BugPOI : public CNPCSpawnDestination
{
public:
	enum POIType
	{
		Start = 0,
		End = 1
	};

	DECLARE_CLASS( BugPOI, CNPCSpawnDestination );
	
	DECLARE_DATADESC();

	// Constructor
	BugPOI()
	{
		m_nTypeOfPOI = Start;
		m_nThreshold = 0;
		m_flSpawnRadius = 0.0;
		nextPOI = NULL;
		m_sObjectiveName = "ARGH!";
		m_sObjectiveDescription = "Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry's standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book. It has survived not only five centuries, but also the leap into electronic typesetting, remaining essentially unchanged. It was popularised in the 1960s with the release of Letraset sheets containing Lorem Ipsum passages, and more recently with desktop publishing software like Aldus PageMaker including versions of Lorem Ipsum.";
	}

	// In-game information (used in the game history)
	const char * m_sObjectiveName;
	const char * m_sObjectiveDescription;

	// Is this a start or end POI?
	POIType m_nTypeOfPOI;

	// For end points, how many bugs need to reach it for the "objective" to be completed?
	int m_nThreshold;

	// The destination POI for this POI (the only time this is allowed to be empty is the final POI in a level!)
	string_t m_sDestinationPOI;

	// How far out will bugs spawn from the POI (this is used to avoid bugs just spawning on top of eachother)
	float m_flSpawnRadius;

	BugPOI *nextPOI;
};

#endif