#include "cbase.h"
#include "sp2_round.h"
// memdbgon must be the last include file in a .cpp file!!!
#include "tier0/memdbgon.h"





LINK_ENTITY_TO_CLASS( sp2_round, Sp2Round );

// Describe the data fields for the brain bug
BEGIN_DATADESC( Sp2Round )
	// For save/load
	DEFINE_FIELD( m_nAntAmount, FIELD_INTEGER ),
	DEFINE_FIELD( m_nSpecialAntAmount, FIELD_INTEGER ),
	DEFINE_FIELD( m_nRoundNumber, FIELD_INTEGER ),
	DEFINE_FIELD( m_nTurretSpawnAmount, FIELD_INTEGER ),

	DEFINE_FIELD( m_flAntRunProbability, FIELD_FLOAT ),
	DEFINE_FIELD( m_flSpecialsRunProbability, FIELD_FLOAT ),
	DEFINE_FIELD( m_flSpecialsPlayerAvoidance, FIELD_FLOAT ),
	DEFINE_FIELD( m_flRoundDelay, FIELD_FLOAT ),

	DEFINE_KEYFIELD( m_nAntAmount, FIELD_INTEGER, "ants" ),
	DEFINE_KEYFIELD( m_nSpecialAntAmount, FIELD_INTEGER, "specials" ),
	DEFINE_KEYFIELD( m_nRoundNumber, FIELD_INTEGER, "round" ),
	DEFINE_KEYFIELD( m_nTurretSpawnAmount, FIELD_INTEGER, "turrets" ),

	DEFINE_KEYFIELD( m_flAntRunProbability, FIELD_FLOAT, "antRunPercentage" ),
	DEFINE_KEYFIELD( m_flSpecialsRunProbability, FIELD_FLOAT, "specialsRunPercentage" ),
	DEFINE_KEYFIELD( m_flSpecialsPlayerAvoidance, FIELD_FLOAT, "specialsPlayerAvoidance" ),
	DEFINE_KEYFIELD( m_flSpecialsTurretResistance, FIELD_FLOAT, "specialsTurretResistance" ),
	DEFINE_KEYFIELD( m_flRoundDelay, FIELD_FLOAT, "roundDelay" ),

	DEFINE_OUTPUT( m_OnNewRound, "NewRound" ),
END_DATADESC()

void Sp2Round::Spawn() 
{
	int maxAmount = m_nAntAmount + m_nSpecialAntAmount;
	specialSpawns = CUtlVector<bool>(0, maxAmount);
	for(int i=0;i<maxAmount;i++)
		specialSpawns.AddToTail(false);

	for(int i=0;i<m_nSpecialAntAmount;i++) 
	{
		int j = random->RandomInt(0, maxAmount - 1);
		while(specialSpawns[j] == true) 
		{
			j = ++j % maxAmount;
		}
		specialSpawns[j] = true;
	}

}

void Sp2Round::FireNewRound()
{
	m_OnNewRound.FireOutput(this,this);
	DevMsg("New round event fired");
}