
#ifndef SDK_NODEWEIGHT_H
#define SDK_NODEWEIGHT_H
#ifdef _WIN32
#pragma once
#endif

class CNodeWeight : public CLogicalEntity
{
public:
	DECLARE_CLASS( CNodeWeight, CLogicalEntity );
	DECLARE_DATADESC();

	// Stores one vector for each node in the navigation network for the current map
	CUtlVector<Vector> CurrentWeights;

	// Purpose: Initialise the internal list(s) of nodeweights
	virtual void Initialize();

	// Purpose: Reset all weights back to the state the should have at the start of a level
	virtual void Reset();

	// Purpose: Perform the updating of the nodewieghts system
	virtual void Update() {};

	// Purpose: Think method used to call the update method
	virtual void UpdateThink();

	// Purpose: Return the current weight of the node with the specified nodeIndex
	virtual Vector GetNodeWeight(int nodeIndex);

	// Purpose: Adjust the current weight of the node with the specified nodeIndex
	// by the given amount
	virtual void ChangeWeight(int nodeIndex, Vector amount);

	// Purpose: Set the current weight of the node with the specified nodeIndex
	// to amount
	virtual void SetWeight(int nodeIndex, Vector amount);

	// Purpose: Return the number of nodes in the nodeweight system
	virtual int Count();
};

#endif